Type (Hibernate JavaDocs)
Date: 2012-04-05

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.hibernate.type
Interface Type

All Superinterfaces:
  Serializable

All Known Subinterfaces:
  AbstractComponentType, AssociationType, BasicType, CompositeType, DiscriminatorType<T>, IdentifierType<T>, SingleColumnType<T>, VersionType<T>

All Known Implementing Classes:
  AbstractBynaryType, AbstractCharArrayType, AbstractLobType, AbstractLongBinaryType, AbstractLongStringType, AbstractSingleColumnStandardBasicType, AbstractStandardBasicType, AbstractType, AdaptedImmutableType, AnyType, ArrayType, BagType, BigDecimalType, BigIntegerType, BinaryType, BlobType, BooleanType, ByteArrayBlobType, ByteType, CalendarDateType, CalendarType, CharacterArrayClobType, CharacterArrayType, CharacterType, CharArrayType, CharBooleanType, ClassType, ClobType, CollectionType, ComponentType, CompositeCustomType, CurrencyType, CustomCollectionType, CustomType, DateType, DbTimestampType, DiscriminatorType, DoubleType, EmbeddedComponentType, EntityType, FloatType, IdentifierBagType, ImageType, ImmutableType, IntegerType, ListType, LocaleType, LongType, ManyToOneType, MapType, MaterializedBlobType, MaterializedClobType, MetaType, MutableType, NullableType, NumericBooleanType, ObjectType, OneToOneType, OrderedMapType, OrderedSetType, PostgresUUIDType, PrimitiveByteArrayBlobType, PrimitiveCharacterArrayClobType, SerializableToBlobType, SerializableType, SetType, ShortType, SortedMapType, SortedSetType, SpecialOneToOneType, StringType, TextType, TimestampType, TimeType, TimeZoneType, TrueFalseType, UrlType, UUIDBinaryType, UUIDCharType, WrappedMaterializedBlobType, WrapperBinaryType, YesNoType

    public interface Type

extends Serializable

Defines a mapping between a Java type and one or more JDBC types, as well as describing the in-memory semantics of the given java type (how do we check it for 'dirtiness', how do we copy values, etc).

Application developers needing custom types can implement this interface (either directly or via subclassing an existing impl) or by the (slightly more stable, though more limited) `UserType` interface.

Implementations of this interface must certainly be thread-safe. It is recommended that they be immutable as well, though that is difficult to achieve completely given the no-arg constructor requirement for custom types.

Method Summary
`Object` | `assemble(Serializable cached, SessionImplementor session, Object owner)` Reconstruct the object from its disassembled state.
`void` | `beforeAssemble(Serializable cached, SessionImplementor session)` Called before assembling a query result set from the query cache, to allow batch fetching of entities missing from the second-level cache.
`int` | `compare(Object x, Object y)` Perform a `Comparator` style comparison between values
`Object` | `deepCopy(Object value, SessionFactoryImplementor factory)` Return a deep copy of the persistent state, stopping at entities and at collections.
`Size[]` | `defaultSizes(Mapping mapping)` Defines the column sizes to use according to this type if the user did not explicitly say (and if no `dictatedSizes(org.hibernate.engine.spi.Mapping)` were given).
`Size[]` | `dictatedSizes(Mapping mapping)` Return the column sizes dictated by this type.
`Serializable` | `disassemble(Object value, SessionImplementor session, Object owner)` Return a disassembled representation of the object.
`Object` | `fromXMLNode(org.dom4j.Node xml, Mapping factory)` Parse the XML representation of an instance.
`int` | `getColumnSpan(Mapping mapping)` How many columns are used to persist this type.
`int` | `getHashCode(Object x)` Get a hash code, consistent with persistence "equality".
`int` | `getHashCode(Object x, SessionFactoryImplementor factory)` Get a hash code, consistent with persistence "equality".
`String` | `getName()` Returns the abbreviated name of the type.
`Class` | `getReturnedClass()` The class returned by `nullSafeGet(java.sql.ResultSet, java.lang.String[], org.hibernate.engine.spi.SessionImplementor, java.lang.Object)` methods.
`Type` | `getSemiResolvedType(SessionFactoryImplementor factory)` As part of 2-phase loading, when we perform resolving what is the resolved type for this type? Generally speaking the type and its semi-resolved type will be the same.
`Object` | `hydrate(ResultSet rs, String[] names, SessionImplementor session, Object owner)` Extract a value from the JDBC result set.
`boolean` | `isAnyType()` Return true if the implementation is castable to `AnyType`.
`boolean` | `isAssociationType()` Return true if the implementation is castable to `AssociationType`.
`boolean` | `isCollectionType()` Return true if the implementation is castable to `CollectionType`.
`boolean` | `isComponentType()` Return true if the implementation is castable to `CompositeType`.
`boolean` | `isDirty(Object oldState, Object currentState, boolean[] checkable, SessionImplementor session)` Should the parent be considered dirty, given both the old and current value?
`boolean` | `isDirty(Object old, Object current, SessionImplementor session)` Should the parent be considered dirty, given both the old and current value?
`boolean` | `isEntityType()` Return true if the implementation is castable to `EntityType`.
`boolean` | `isEqual(Object x, Object y)` Compare two instances of the class mapped by this type for persistence "equality" (equality of persistent state).
`boolean` | `isEqual(Object x, Object y, SessionFactoryImplementor factory)` Compare two instances of the class mapped by this type for persistence "equality" (equality of persistent state).
`boolean` | `isModified(Object dbState, Object currentState, boolean[] checkable, SessionImplementor session)` Has the value been modified compared to the current database state? The difference between this and the `isDirty(java.lang.Object, java.lang.Object, org.hibernate.engine.spi.SessionImplementor)` methods is that here we need to account for "partially" built values.
`boolean` | `isMutable()` Are objects of this type mutable.
`boolean` | `isSame(Object x, Object y)` Compare two instances of the class mapped by this type for persistence "equality" (equality of persistent state) taking a shortcut for entity references.
`boolean` | `isXMLElement()`
`Object` | `nullSafeGet(ResultSet rs, String[] names, SessionImplementor session, Object owner)` Extract a value of the `mapped class` from the JDBC result set.
`Object` | `nullSafeGet(ResultSet rs, String name, SessionImplementor session, Object owner)` Extract a value of the `mapped class` from the JDBC result set.
`void` | `nullSafeSet(PreparedStatement st, Object value, int index, boolean[] settable, SessionImplementor session)` Bind a value represented by an instance of the `mapped class` to the JDBC prepared statement, ignoring some columns as dictated by the 'settable' parameter.
`void` | `nullSafeSet(PreparedStatement st, Object value, int index, SessionImplementor session)` Bind a value represented by an instance of the `mapped class` to the JDBC prepared statement.
`Object` | `replace(Object original, Object target, SessionImplementor session, Object owner, Map copyCache)` During merge, replace the existing (target) value in the entity we are merging to with a new (original) value from the detached entity we are merging.
`Object` | `replace(Object original, Object target, SessionImplementor session, Object owner, Map copyCache, ForeignKeyDirection foreignKeyDirection)` During merge, replace the existing (target) value in the entity we are merging to with a new (original) value from the detached entity we are merging.
`Object` | `resolve(Object value, SessionImplementor session, Object owner)` The second phase of 2-phase loading.
`Object` | `semiResolve(Object value, SessionImplementor session, Object owner)` Given a hydrated, but unresolved value, return a value that may be used to reconstruct property-ref associations.
`void` | `setToXMLNode(org.dom4j.Node node, Object value, SessionFactoryImplementor factory)` A representation of the value to be embedded in an XML element.
`int[]` | `sqlTypes(Mapping mapping)` Return the JDBC types codes (per `Types`) for the columns mapped by this type.
`boolean[]` | `toColumnNullness(Object value, Mapping mapping)` Given an instance of the type, return an array of boolean, indicating which mapped columns would be null.
`String` | `toLoggableString(Object value, SessionFactoryImplementor factory)` Generate a representation of the value for logging purposes.

Method Detail

### isAssociationType

    boolean isAssociationType()

  Return true if the implementation is castable to `AssociationType`. This does not necessarily imply that the type actually represents an association. Essentially a polymorphic version of `(type instanceof AssociationType.class)`

  Returns:
    True if this type is also an `AssociationType` implementor; false otherwise.

### isCollectionType

    boolean isCollectionType()

  Return true if the implementation is castable to `CollectionType`. Essentially a polymorphic version of `(type instanceof CollectionType.class)`

  A `CollectionType` is additionally an `AssociationType`; so if this method returns true, `isAssociationType()` should also return true.

  Returns:
    True if this type is also an `CollectionType` implementor; false otherwise.

### isEntityType

    boolean isEntityType()

  Return true if the implementation is castable to `EntityType`. Essentially a polymorphic version of `(type instanceof EntityType.class)`.

  An `EntityType` is additionally an `AssociationType`; so if this method returns true, `isAssociationType()` should also return true.

  Returns:
    True if this type is also an `EntityType` implementor; false otherwise.

### isAnyType

    boolean isAnyType()

  Return true if the implementation is castable to `AnyType`. Essentially a polymorphic version of `(type instanceof AnyType.class)`.

  An `AnyType` is additionally an `AssociationType`; so if this method returns true, `isAssociationType()` should also return true.

  Returns:
    True if this type is also an `AnyType` implementor; false otherwise.

### isComponentType

    boolean isComponentType()

  Return true if the implementation is castable to `CompositeType`. Essentially a polymorphic version of `(type instanceof CompositeType.class)`. A component type may own collections or associations and hence must provide certain extra functionality.

  Returns:
    True if this type is also an `CompositeType` implementor; false otherwise.

### getColumnSpan

    int getColumnSpan(Mapping mapping)
                      throws MappingException

  How many columns are used to persist this type. Always the same as `sqlTypes(mapping).length`

  Parameters:
    `mapping` - The mapping object :/
  Returns:
    The number of columns
  Throws:
    `MappingException` - Generally indicates an issue accessing the passed mapping object.

### sqlTypes

    int[] sqlTypes(Mapping mapping)
                   throws MappingException

  Return the JDBC types codes (per `Types`) for the columns mapped by this type.

  NOTE: The number of elements in this array matches the return from `getColumnSpan(org.hibernate.engine.spi.Mapping)`.

  Parameters:
    `mapping` - The mapping object :/
  Returns:
    The JDBC type codes.
  Throws:
    `MappingException` - Generally indicates an issue accessing the passed mapping object.

### dictatedSizes

    Size[] dictatedSizes(Mapping mapping)
                         throws MappingException

  Return the column sizes dictated by this type. For example, the mapping for a `char`/`Character` would have a dictated length limit of 1; for a string-based `UUID` would have a size limit of 36; etc.

  NOTE: The number of elements in this array matches the return from `getColumnSpan(org.hibernate.engine.spi.Mapping)`.

  Parameters:
    `mapping` - The mapping object :/
  Returns:
    The dictated sizes.
  Throws:
    `MappingException` - Generally indicates an issue accessing the passed mapping object.

### defaultSizes

    Size[] defaultSizes(Mapping mapping)
                        throws MappingException

  Defines the column sizes to use according to this type if the user did not explicitly say (and if no `dictatedSizes(org.hibernate.engine.spi.Mapping)` were given).

  NOTE: The number of elements in this array matches the return from `getColumnSpan(org.hibernate.engine.spi.Mapping)`.

  Parameters:
    `mapping` - The mapping object :/
  Returns:
    The default sizes.
  Throws:
    `MappingException` - Generally indicates an issue accessing the passed mapping object.

### getReturnedClass

    Class getReturnedClass()

  The class returned by `nullSafeGet(java.sql.ResultSet, java.lang.String[], org.hibernate.engine.spi.SessionImplementor, java.lang.Object)` methods. This is used to establish the class of an array of this type.

  Returns:
    The java type class handled by this type.

### isXMLElement

    boolean isXMLElement()

### isSame

    boolean isSame(Object x,
                   Object y)
                   throws HibernateException

  Compare two instances of the class mapped by this type for persistence "equality" (equality of persistent state) taking a shortcut for entity references.

  For most types this should equate to an `equals` check on the values. For associations the implication is a bit different. For most types it is conceivable to simply delegate to `isEqual(java.lang.Object, java.lang.Object)`

  Parameters:
    `x` - The first value
    `y` - The second value
  Returns:
    True if there are considered the same (see discussion above).
  Throws:
    `HibernateException` - A problem occurred performing the comparison

### isEqual

    boolean isEqual(Object x,
                    Object y)
                    throws HibernateException

  Compare two instances of the class mapped by this type for persistence "equality" (equality of persistent state).

  This should always equate to some form of comparison of the value's internal state. As an example, for something like a date the comparison should be based on its internal "time" state based on the specific portion it is meant to represent (timestamp, date, time).

  Parameters:
    `x` - The first value
    `y` - The second value
  Returns:
    True if there are considered equal (see discussion above).
  Throws:
    `HibernateException` - A problem occurred performing the comparison

### isEqual

    boolean isEqual(Object x,
                    Object y,
                    SessionFactoryImplementor factory)
                    throws HibernateException

  Compare two instances of the class mapped by this type for persistence "equality" (equality of persistent state).

  This should always equate to some form of comparison of the value's internal state. As an example, for something like a date the comparison should be based on its internal "time" state based on the specific portion it is meant to represent (timestamp, date, time).

  Parameters:
    `x` - The first value
    `y` - The second value
    `factory` - The session factory
  Returns:
    True if there are considered equal (see discussion above).
  Throws:
    `HibernateException` - A problem occurred performing the comparison

### getHashCode

    int getHashCode(Object x)
                    throws HibernateException

  Get a hash code, consistent with persistence "equality". Again for most types the normal usage is to delegate to the value's `hashCode`.

  Parameters:
    `x` - The value for which to retrieve a hash code
  Returns:
    The hash code
  Throws:
    `HibernateException` - A problem occurred calculating the hash code

### getHashCode

    int getHashCode(Object x,
                    SessionFactoryImplementor factory)
                    throws HibernateException

  Get a hash code, consistent with persistence "equality". Again for most types the normal usage is to delegate to the value's `hashCode`.

  Parameters:
    `x` - The value for which to retrieve a hash code
    `factory` - The session factory
  Returns:
    The hash code
  Throws:
    `HibernateException` - A problem occurred calculating the hash code

### compare

    int compare(Object x,
                Object y)

  Perform a `Comparator` style comparison between values

  Parameters:
    `x` - The first value
    `y` - The second value
  Returns:
    The comparison result. See `Comparator.compare(T, T)` for a discussion.

### isDirty

    boolean isDirty(Object old,
                    Object current,
                    SessionImplementor session)
                    throws HibernateException

  Should the parent be considered dirty, given both the old and current value?

  Parameters:
    `old` - the old value
    `current` - the current value
    `session` - The session from which the request originated.
  Returns:
    true if the field is dirty
  Throws:
    `HibernateException` - A problem occurred performing the checking

### isDirty

    boolean isDirty(Object oldState,
                    Object currentState,
                    boolean[] checkable,
                    SessionImplementor session)
                    throws HibernateException

  Should the parent be considered dirty, given both the old and current value?

  Parameters:
    `oldState` - the old value
    `currentState` - the current value
    `checkable` - An array of booleans indicating which columns making up the value are actually checkable
    `session` - The session from which the request originated.
  Returns:
    true if the field is dirty
  Throws:
    `HibernateException` - A problem occurred performing the checking

### isModified

    boolean isModified(Object dbState,
                       Object currentState,
                       boolean[] checkable,
                       SessionImplementor session)
                       throws HibernateException

  Has the value been modified compared to the current database state? The difference between this and the `isDirty(java.lang.Object, java.lang.Object, org.hibernate.engine.spi.SessionImplementor)` methods is that here we need to account for "partially" built values. This is really only an issue with association types. For most type implementations it is enough to simply delegate to `isDirty(java.lang.Object, java.lang.Object, org.hibernate.engine.spi.SessionImplementor)` here/

  Parameters:
    `dbState` - the database state, in a "hydrated" form, with identifiers unresolved
    `currentState` - the current state of the object
    `checkable` - which columns are actually updatable
    `session` - The session from which the request originated.
  Returns:
    true if the field has been modified
  Throws:
    `HibernateException` - A problem occurred performing the checking

### nullSafeGet

    Object nullSafeGet(ResultSet rs,
                       String[] names,
                       SessionImplementor session,
                       Object owner)
                       throws HibernateException,
                              SQLException

  Extract a value of the `mapped class` from the JDBC result set. Implementors should handle possibility of null values.

  Parameters:
    `rs` - The result set from which to extract value.
    `names` - the column names making up this type value (use to read from result set)
    `session` - The originating session
    `owner` - the parent entity
  Returns:
    The extracted value
  Throws:
    `HibernateException` - An error from Hibernate
    `SQLException` - An error from the JDBC driver
  See Also:
    `alternative, 2-phase property initialization`

### nullSafeGet

    Object nullSafeGet(ResultSet rs,
                       String name,
                       SessionImplementor session,
                       Object owner)
                       throws HibernateException,
                              SQLException

  Extract a value of the `mapped class` from the JDBC result set. Implementors should handle possibility of null values. This form might be called if the type is known to be a single-column type.

  Parameters:
    `rs` - The result set from which to extract value.
    `name` - the column name making up this type value (use to read from result set)
    `session` - The originating session
    `owner` - the parent entity
  Returns:
    The extracted value
  Throws:
    `HibernateException` - An error from Hibernate
    `SQLException` - An error from the JDBC driver

### nullSafeSet

    void nullSafeSet(PreparedStatement st,
                     Object value,
                     int index,
                     boolean[] settable,
                     SessionImplementor session)
                     throws HibernateException,
                            SQLException

  Bind a value represented by an instance of the `mapped class` to the JDBC prepared statement, ignoring some columns as dictated by the 'settable' parameter. Implementors should handle the possibility of null values. A multi-column type should bind parameters starting from `index`.

  Parameters:
    `st` - The JDBC prepared statement to which to bind
    `value` - the object to write
    `index` - starting parameter bind index
    `settable` - an array indicating which columns to bind/ignore
    `session` - The originating session
  Throws:
    `HibernateException` - An error from Hibernate
    `SQLException` - An error from the JDBC driver

### nullSafeSet

    void nullSafeSet(PreparedStatement st,
                     Object value,
                     int index,
                     SessionImplementor session)
                     throws HibernateException,
                            SQLException

  Bind a value represented by an instance of the `mapped class` to the JDBC prepared statement. Implementors should handle possibility of null values. A multi-column type should bind parameters starting from `index`.

  Parameters:
    `st` - The JDBC prepared statement to which to bind
    `value` - the object to write
    `index` - starting parameter bind index
    `session` - The originating session
  Throws:
    `HibernateException` - An error from Hibernate
    `SQLException` - An error from the JDBC driver

### toLoggableString

    String toLoggableString(Object value,
                            SessionFactoryImplementor factory)
                            throws HibernateException

  Generate a representation of the value for logging purposes.

  Parameters:
    `value` - The value to be logged
    `factory` - The session factory
  Returns:
    The loggable representation
  Throws:
    `HibernateException` - An error from Hibernate

### setToXMLNode

    void setToXMLNode(org.dom4j.Node node,
                      Object value,
                      SessionFactoryImplementor factory)
                      throws HibernateException

  A representation of the value to be embedded in an XML element.

  Parameters:
    `node` - The XML node to which to write the value
    `value` - The value to write
    `factory` - The session factory
  Throws:
    `HibernateException` - An error from Hibernate

### fromXMLNode

    Object fromXMLNode(org.dom4j.Node xml,
                       Mapping factory)
                       throws HibernateException

  Parse the XML representation of an instance.

  Parameters:
    `xml` - The XML node from which to read the value
    `factory` - The session factory
  Returns:
    an instance of the `mapped class`
  Throws:
    `HibernateException` - An error from Hibernate

### getName

    String getName()

  Returns the abbreviated name of the type.

  Returns:
    String the Hibernate type name

### deepCopy

    Object deepCopy(Object value,
                    SessionFactoryImplementor factory)
                    throws HibernateException

  Return a deep copy of the persistent state, stopping at entities and at collections.

  Parameters:
    `value` - The value to be copied
    `factory` - The session factory
  Returns:
    The deep copy
  Throws:
    `HibernateException` - An error from Hibernate

### isMutable

    boolean isMutable()

  Are objects of this type mutable. (With respect to the referencing object ... entities and collections are considered immutable because they manage their own internal state.)

  Returns:
    boolean

### disassemble

    Serializable disassemble(Object value,
                             SessionImplementor session,
                             Object owner)
                             throws HibernateException

  Return a disassembled representation of the object. This is the value Hibernate will use in second level caching, so care should be taken to break values down to their simplest forms; for entities especially, this means breaking them down into their constituent parts.

  Parameters:
    `value` - the value to cache
    `session` - the originating session
    `owner` - optional parent entity object (needed for collections)
  Returns:
    the disassembled, deep cloned state
  Throws:
    `HibernateException` - An error from Hibernate

### assemble

    Object assemble(Serializable cached,
                    SessionImplementor session,
                    Object owner)
                    throws HibernateException

  Reconstruct the object from its disassembled state. This method is the reciprocal of `disassemble(java.lang.Object, org.hibernate.engine.spi.SessionImplementor, java.lang.Object)`

  Parameters:
    `cached` - the disassembled state from the cache
    `session` - the originating session
    `owner` - the parent entity object
  Returns:
    the (re)assembled object
  Throws:
    `HibernateException` - An error from Hibernate

### beforeAssemble

    void beforeAssemble(Serializable cached,
                        SessionImplementor session)

  Called before assembling a query result set from the query cache, to allow batch fetching of entities missing from the second-level cache.

  Parameters:
    `cached` - The key
    `session` - The originating session

### hydrate

    Object hydrate(ResultSet rs,
                   String[] names,
                   SessionImplementor session,
                   Object owner)
                   throws HibernateException,
                          SQLException

  Extract a value from the JDBC result set. This is useful for 2-phase property initialization - the second phase is a call to `resolve(java.lang.Object, org.hibernate.engine.spi.SessionImplementor, java.lang.Object)` This hydrated value will be either:
  - in the case of an entity or collection type, the key
  - otherwise, the value itself

  Parameters:
    `rs` - The JDBC result set
    `names` - the column names making up this type value (use to read from result set)
    `session` - The originating session
    `owner` - the parent entity
  Returns:
    An entity or collection key, or an actual value.
  Throws:
    `HibernateException` - An error from Hibernate
    `SQLException` - An error from the JDBC driver
  See Also:
    `resolve(java.lang.Object, org.hibernate.engine.spi.SessionImplementor, java.lang.Object)`

### resolve

    Object resolve(Object value,
                   SessionImplementor session,
                   Object owner)
                   throws HibernateException

  The second phase of 2-phase loading. Only really pertinent for entities and collections. Here we resolve the identifier to an entity or collection instance

  Parameters:
    `value` - an identifier or value returned by `hydrate()`
    `owner` - the parent entity
    `session` - the session
  Returns:
    the given value, or the value associated with the identifier
  Throws:
    `HibernateException` - An error from Hibernate
  See Also:
    `hydrate(java.sql.ResultSet, java.lang.String[], org.hibernate.engine.spi.SessionImplementor, java.lang.Object)`

### semiResolve

    Object semiResolve(Object value,
                       SessionImplementor session,
                       Object owner)
                       throws HibernateException

  Given a hydrated, but unresolved value, return a value that may be used to reconstruct property-ref associations.

  Parameters:
    `value` - The unresolved, hydrated value
    `session` - THe originating session
    `owner` - The value owner
  Returns:
    The semi-resolved value
  Throws:
    `HibernateException` - An error from Hibernate

### getSemiResolvedType

    Type getSemiResolvedType(SessionFactoryImplementor factory)

  As part of 2-phase loading, when we perform resolving what is the resolved type for this type? Generally speaking the type and its semi-resolved type will be the same. The main deviation from this is in the case of an entity where the type would be the entity type and semi-resolved type would be its identifier type

  Parameters:
    `factory` - The session factory
  Returns:
    The semi-resolved type

### replace

    Object replace(Object original,
                   Object target,
                   SessionImplementor session,
                   Object owner,
                   Map copyCache)
                   throws HibernateException

  During merge, replace the existing (target) value in the entity we are merging to with a new (original) value from the detached entity we are merging. For immutable objects, or null values, it is safe to simply return the first parameter. For mutable objects, it is safe to return a copy of the first parameter. For objects with component values, it might make sense to recursively replace component values.

  Parameters:
    `original` - the value from the detached entity being merged
    `target` - the value in the managed entity
    `session` - The originating session
    `owner` - The owner of the value
    `copyCache` - The cache of already copied/replaced values
  Returns:
    the value to be merged
  Throws:
    `HibernateException` - An error from Hibernate

### replace

    Object replace(Object original,
                   Object target,
                   SessionImplementor session,
                   Object owner,
                   Map copyCache,
                   ForeignKeyDirection foreignKeyDirection)
                   throws HibernateException

  During merge, replace the existing (target) value in the entity we are merging to with a new (original) value from the detached entity we are merging. For immutable objects, or null values, it is safe to simply return the first parameter. For mutable objects, it is safe to return a copy of the first parameter. For objects with component values, it might make sense to recursively replace component values.

  Parameters:
    `original` - the value from the detached entity being merged
    `target` - the value in the managed entity
    `session` - The originating session
    `owner` - The owner of the value
    `copyCache` - The cache of already copied/replaced values
    `foreignKeyDirection` - For associations, which direction does the foreign key point?
  Returns:
    the value to be merged
  Throws:
    `HibernateException` - An error from Hibernate

### toColumnNullness

    boolean[] toColumnNullness(Object value,
                               Mapping mapping)

  Given an instance of the type, return an array of boolean, indicating which mapped columns would be null.

  Parameters:
    `value` - an instance of the type
    `mapping` - The mapping abstraction
  Returns:
    array indicating column nullness for a value instance

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2012 Red Hat, Inc. All Rights Reserved.